/*
 *  Copyright (C) 2009-2010 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "configFrame.h"
#include "iconFactory.h"
#include "textLabel.h"

FXIMPLEMENT(configFrame, FXVerticalFrame, 0, 0)

configFrame::configFrame(FXComposite* p, const char* title, const char* credits, const char* link) :
	FXVerticalFrame(p, LAYOUT_FILL_X, 0,0,0,0, 0,0,0,0, 0,0) {

	if (credits) {
		FXLabel* cred=new FXLabel(this, credits, 0, LAYOUT_FILL_X);
		cred->setBackColor(FXRGB(255,255,255));
	}

	if (link) {
		textLabel* lnk=new textLabel(this, link, LAYOUT_FILL_X);
		lnk->setBackColor(FXRGB(255,255,255));
	}

	FXHorizontalFrame* top=new FXHorizontalFrame(this, LAYOUT_FILL_X);

	_matrix=new FXMatrix(top, 2, MATRIX_BY_COLUMNS|LAYOUT_FILL);
	_extraLeft=new FXHorizontalFrame(top, LAYOUT_FILL);

	_extraBottom=new FXVerticalFrame(this, LAYOUT_FILL);
}
