/*
 *  Copyright (C) 2009 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef CONFIG_FRAME_H
#define CONFIG_FRAME_H

#include <fx.h>

class configFrame : public FXVerticalFrame {
	FXDECLARE(configFrame)
private:
	FXMatrix		*_matrix;
	FXHorizontalFrame	*_extraLeft;
	FXVerticalFrame		*_extraBottom;

private:
	configFrame(const configFrame&);
	configFrame& operator=(const configFrame&);

protected:
	configFrame() {};

	FXMatrix* matrix() const { return _matrix; }
	FXHorizontalFrame* extraLeft() const { return _extraLeft; }
	FXVerticalFrame* extraBottom() const { return _extraBottom; }

public:
	configFrame(FXComposite* p, const char* title, const char* credits=0, const char* link=0);
	virtual ~configFrame() {};
};

#endif
