/*
 *  Copyright (C) 2006-2008 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "AboutDialog.h"
#include "info.h"
#include "credits.h"
#include "iconFactory.h"
#include "textLabel.h"

/* created by reswrap from file foxbig.gif */
const unsigned char icon_foxbig[164]={
  0x47,0x49,0x46,0x38,0x39,0x61,0x20,0x00,0x20,0x00,0xf0,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x21,0xf9,0x04,0x01,0x00,0x00,0x01,0x00,0x2c,0x00,0x00,0x00,0x00,
  0x20,0x00,0x20,0x00,0x00,0x02,0x7b,0x8c,0x8f,0xa9,0xcb,0xed,0x0f,0x63,0x04,0xd4,
  0x50,0xf0,0x2e,0xbb,0x35,0x70,0x9c,0x7c,0x60,0xf8,0x59,0xe2,0x21,0x8e,0xa8,0xb6,
  0x69,0x9c,0xc3,0x36,0x29,0xdc,0x65,0x2f,0xbd,0xc4,0xa6,0x9a,0xd7,0xab,0xae,0xeb,
  0xdd,0x66,0x3b,0xdb,0xf0,0x54,0xa4,0x1d,0x4b,0x49,0x99,0x6f,0xe7,0x0b,0x2a,0xa4,
  0x9e,0x27,0x15,0x71,0x9d,0xde,0x5a,0x3c,0x6e,0xb5,0xfb,0x33,0x8e,0xae,0x64,0xe6,
  0x0f,0xf8,0x3c,0x3b,0xa3,0xe9,0xa6,0x57,0x02,0x8f,0x87,0x2c,0x28,0xd8,0x84,0x3e,
  0x27,0x61,0x5e,0x43,0xfa,0xfe,0x3b,0x85,0xf7,0xe7,0x21,0x08,0x62,0x98,0x23,0x48,
  0xa8,0x68,0x78,0xa8,0x48,0xf2,0xb5,0xc7,0x72,0x38,0xd8,0x26,0x67,0x79,0x89,0x69,
  0x59,0x00,0x00,0x3b
  };


/* created by reswrap from file drf.gif */
const unsigned char icon_drf[133]={
  0x47,0x49,0x46,0x38,0x39,0x61,0x10,0x00,0x10,0x00,0xf2,0x00,0x00,0x15,0x15,0x15,
  0x00,0xff,0x00,0xff,0xff,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x21,0xf9,0x04,0x01,0x00,0x00,0x04,0x00,0x2c,0x00,0x00,
  0x00,0x00,0x10,0x00,0x10,0x00,0x00,0x03,0x4a,0x08,0xba,0xdc,0x3a,0x30,0xbe,0x08,
  0x1f,0x1b,0x76,0x61,0x80,0x09,0x07,0x5e,0xe7,0x69,0xe0,0x17,0x82,0x44,0x7a,0x72,
  0xdd,0xb7,0xa4,0x40,0xa0,0xc8,0x70,0x60,0xd3,0x9e,0x1c,0xa3,0xfb,0x9b,0xc7,0xb8,
  0x9d,0xaa,0x26,0x24,0x2a,0x54,0x00,0x81,0x12,0xe5,0x51,0x0a,0x98,0xc9,0x27,0xac,
  0x29,0x45,0x2e,0x3d,0xb0,0xab,0x55,0x7a,0x8c,0x32,0x9b,0xbc,0xec,0x77,0x54,0xc2,
  0xfa,0x54,0x09,0x00,0x3b
  };

FXIMPLEMENT(aboutDialog, FXDialogBox, 0, 0)

aboutDialog::aboutDialog(FXWindow* win, FXIcon *icon) :
	FXDialogBox(win, FXString::null, DECOR_TITLE|DECOR_BORDER, 0,0,0,0, 0,0,0,0, 0,0) {

	setTitle(FXStringFormat("%s %s", tr("About "), PACKAGE_NAME));

	FXHorizontalFrame* buttons=new FXHorizontalFrame(this, LAYOUT_FILL_X|FRAME_SUNKEN|PACK_UNIFORM_WIDTH, 0,0,0,0, 0,0,0,0, 0,0);

	FXSwitcher* switcher=new FXSwitcher(this, LAYOUT_FILL_X, 0,0,0,0, 0,0,0,0);

	new FXButton(buttons, tr("&Info"), 0, switcher, FXSwitcher::ID_OPEN_FIRST+0, FRAME_RAISED|LAYOUT_FILL_X);
	new FXButton(buttons, tr("C&ontact"), 0, switcher, FXSwitcher::ID_OPEN_FIRST+1, FRAME_RAISED|LAYOUT_FILL_X);
	new FXButton(buttons, tr("C&redits"), 0, switcher, FXSwitcher::ID_OPEN_FIRST+2, FRAME_RAISED|LAYOUT_FILL_X);
	new FXButton(buttons, tr("&Fox"), 0, switcher, FXSwitcher::ID_OPEN_FIRST+3, FRAME_RAISED|LAYOUT_FILL_X);
	new FXButton(buttons, tr("&License"), 0, switcher, FXSwitcher::ID_OPEN_FIRST+4, FRAME_RAISED|LAYOUT_FILL_X);

	// Info
	FXVerticalFrame* frame=new FXVerticalFrame(switcher, LAYOUT_FILL, 0,0,0,0, 15,15,15,15);
	new FXLabel(frame,
		FXStringFormat("%s\n\n%s %s \n\n%s \302\251 %s %s", PACKAGE_NAME, tr("Version"),
			PACKAGE_VERSION, tr("Copyright"), YEAR, AUTHOR),
		icon, LAYOUT_FILL_X|JUSTIFY_HZ_APART|ICON_AFTER_TEXT);

	// Contact
	frame=new FXVerticalFrame(switcher, LAYOUT_FILL, 0,0,0,0, 15,15,15,15);
	new textLabel(frame, FXString(WEBSITE));
	new FXLabel(frame, FXStringFormat("%s: %s", tr("E-mail"), PACKAGE_BUGREPORT));

	// Credits
	frame=new FXVerticalFrame(switcher, FRAME_SUNKEN|LAYOUT_FILL, 0,0,0,0, 0,0,0,0);
	FXScrollWindow* sw=new FXScrollWindow(frame, LAYOUT_FILL);
	new FXLabel(sw, FXString(CREDITS), 0, LAYOUT_FILL);

	// Fox
	frame=new FXVerticalFrame(switcher,LAYOUT_FILL, 0,0,0,0, 15,15,15,15);
	new FXLabel(frame,
		FXStringFormat("%s\n\n%s %d.%d.%d",
			tr("Using the FOX C++ GUI Library"),
			tr("Version"), fxversion[0], fxversion[1], fxversion[2]),
		GET_ICON(icon_foxbig), LAYOUT_FILL |JUSTIFY_HZ_APART|ICON_AFTER_TEXT);
	new textLabel(frame, FXString("http://www.fox-tookit.org"));

	// License
	frame=new FXVerticalFrame(switcher, FRAME_SUNKEN|LAYOUT_FILL, 0,0,0,0, 0,0,0,0);
	FXText* text=new FXText(frame, 0, 0, TEXT_READONLY|TEXT_WORDWRAP|LAYOUT_FILL);
	text->setText(GPL_TEXT, strlen(GPL_TEXT));

	new FXSeparator(this);
	FXHorizontalFrame* closebox=new FXHorizontalFrame(this, LAYOUT_FILL, 0,0,0,0);
	new FXLabel(closebox, FXString::null, GET_ICON(icon_drf));
	new FXButton(closebox, tr("&Close"), GET_ICON(icon_dialogcancel), this, FXDialogBox::ID_CANCEL,
		BUTTON_INITIAL|BUTTON_DEFAULT|BUTTON_NORMAL|LAYOUT_RIGHT);
}
