/*
 *  Copyright (C) 2006-2008 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef BOOKMARK_H
#define BOOKMARK_H

#include <fx.h>

#include "list.h"

class bookmark : public list {
	FXDECLARE(bookmark)

private:
	const char	*_type;

private:
	bookmark() {};
	bookmark(const bookmark&);
	bookmark& operator=(const bookmark&);

public:
	bookmark(FXComposite* p, FXObject* tgt, FXSelector sel) :
		list(p, tgt, sel, LAYOUT_FILL|LIST_SINGLESELECT) {};
	virtual ~bookmark() {};

	/// Add bookmark
	void add(const FXString& dirName);

	/// Load bookmarks
	void load(const char* type);

	/// Save and clear bookmarks
	void save();

public:
	enum {
		ID_BM_DEL=list::ID_LAST,
		ID_BM_CLEAR,
		ID_LAST,
	};

public:
	long onDNDDrop(FXObject*, FXSelector, void*);
	long onDNDMotion(FXObject*, FXSelector, void*);
	long onRgtClk(FXObject*, FXSelector, void*);
	long onCmdGet(FXObject*, FXSelector, void*);
	long onCmdDel(FXObject*, FXSelector, void*);
	long onCmdClear(FXObject*, FXSelector, void*);
};

#endif
