/*
 *  Copyright (C) 2010 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "infoLabel.h"

#include "metaData.h"

FXIMPLEMENT(infoLabel, FXLabel, 0, 0)

#define APPENDINFO(info) \
if (data->getInfo(info)) { \
	if (!tip.empty() && tip[tip.length()]!='\n') \
		tip.append('\n'); \
	tip.append(FXStringFormat("%s: %s", tr(data->getKey(info)), data->getInfo(info))); \
}

void infoLabel::setInfo(const metaData *data) {

	tip=FXString::null;
	if (!data) {
		label=FXString::null;
	} else {
		if (data->getInfo(metaData::TITLE)) {
			label=data->getInfo(metaData::TITLE);

			if (data->getInfo(metaData::ARTIST))
				label.append(FXStringFormat(" [%s]", data->getInfo(metaData::ARTIST)));
		} else {
			label=FXPath::title(data->getInfo(metaData::LOCATION));
		}
		APPENDINFO(metaData::TITLE);
		APPENDINFO(metaData::ARTIST);
		APPENDINFO(metaData::ALBUM);
		APPENDINFO(metaData::YEAR);
		APPENDINFO(metaData::TRACK);
		if (tip.empty())
			tip=tr("No info");
	}

	update();
}

// Get default width
FXint infoLabel::getDefaultWidth() {

	return padleft+padright+(border<<1);
}

