/*
 *  Copyright (C) 2010 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef TEXTLABEL_H
#define TEXTLABEL_H

#include <fx.h>

/**
* Custom text label, avoids treating ampersands as accelerators
*/
class textLabel : public FXLabel {
	FXDECLARE(textLabel)

private:
	FXString	_link;

private:
	textLabel() {};
	textLabel(const textLabel&);
	textLabel &operator=(const textLabel&);

	static bool fxexecute(const FXString& link);

public:
	/// Construct label with given text
	textLabel(FXComposite* p, const FXString& text, FXuint opts=LABEL_NORMAL, const FXint maxLength=0);

	virtual ~textLabel();

public:
	enum {
		ID_TIMER=FXLabel::ID_LAST,
		ID_LAST
	};

public:
	long onLeftBtnPress(FXObject*, FXSelector, void*);
	long onEnter(FXObject*, FXSelector, void*);
	long onLeave(FXObject*, FXSelector, void*);
	long onTimer(FXObject*, FXSelector, void*);
};

#endif
