/*
 *  Copyright (C) 2009-2010 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef TRACKLISTBACKEND_H
#define TRACKLISTBACKEND_H

#include "trackList.h"

class trackListBackend : public trackList {

protected:
	tracks		*_tracks;
	FXString	_path;

private:
	trackListBackend();
	trackListBackend(const trackListBackend&);
	trackListBackend& operator= (const trackListBackend&);

protected:
	trackListBackend(const FXString &path) : _path(path) {
		_tracks=new tracks();
	}

	void writeLine(FXFile* file, FXString line) {

		line.append(ENDLINE);
		file->writeBlock(line.text(), line.length());
	}

public:
	virtual ~trackListBackend() {};

	/// Load playlist
	virtual tracks* load() { return 0; }

	/// Save playlist
	virtual bool save(const tracks*) { return false; }
};

#endif
