/*
 *  Copyright (C) 2009-2010 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef TRACKLISTDIR_H
#define TRACKLISTDIR_H

#include "trackListBackend.h"

class trackListDir : public trackListBackend {

public:
	trackListDir(const FXString &path) : trackListBackend(path) {};

	/// Load playlist
	tracks* load() {
		FXString* filelist=0;

		const FXint items=FXDir::listFiles(filelist, _path, "*", FXDir::NoDirs);

		for (int i=0; i<items; i++)
			_tracks->append(FXPath::absolute(_path, filelist[i]));

		delete [] filelist;

		return _tracks;
	}
};

#endif
