/*
 *  Copyright (C) 2011 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef IMAGEDATA_H
#define IMAGEDATA_H

#include <fx.h>

class imageData {

private:
	FXuval _size;
	FXuchar* _data;
	FXString _type;

public:
	imageData(const FXuval size, const FXuchar *data, FXString &type) :
		_size(size), _data(new FXuchar[size]), _type(type) {
		memcpy(_data, data, size);
	}

	~imageData() { delete [] _data; }

	FXuval size(void) { return _size; }
	FXuchar* data(void) { return _data; }
	FXString& type(void) { return _type; }
};

#endif
