/*
 *  Copyright (C) 2006-2010 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef UTILS_H
#define UTILS_H

#include <fx.h>

#ifdef _WIN32
/// Display current playing song on MSN Messenger
void nowPlaying(const bool show, const bool wlm, const FXString& title, const FXString& artist, const FXString& album);

#ifdef UNICODE
/// Convert Unicode string
extern const FXnchar* convertUtf(const FXString& string);
extern const FXchar* convertNc(const FXnchar* string);
#endif
#endif

/// Run external program
void runCmd(const FXString& cmd);

/// Delete a pointer and set it to null
template<class T> inline void delPtr(T*& p) { delete p; p=0; }

/// Generate alternate color
FXColor altColor(FXColor color);

/// Shrink a string if it's too long
extern FXString shrink(const FXString& string);

#endif
